加入收藏 | 设为首页 | 会员中心 | 我要投稿 李大同 (https://www.lidatong.com.cn/)- 科技、建站、经验、云计算、5G、大数据,站长网!
当前位置: 首页 > 大数据 > 正文

03-04 创建和编辑AutoCAD实体(四) 编辑二维命名对象 (6)

发布时间:2020-12-16 22:50:50 所属栏目:大数据 来源:网络整理
导读:8、Explode Objects分解对象 Exploding an object converts the single object to its constituent parts. You use the Explode function to explode an object,and it requires a DBObjectCollection object in which is used to return the resulting obje

8、Explode Objects分解对象

Exploding an object converts the single object to its constituent parts. You use the Explode function to explode an object,and it requires a DBObjectCollection object in which is used to return the resulting objects. For example,exploding a polyline can result in the creation of an object collection that contains multiple lines and arcs.

分解对象就是将单独的对象转变为它的组件。我们使用Explode函数分解对象,该函数需要一个DBObjectCollection对象作为参数来返回分解后的对象。例如,分解多段线会产生一个包含多条直线和圆弧的对象集合。

If a block is exploded,the object collection returned holds the graphical objects in which define the block. After an object is exploded,the original object is left unaltered. If you want the returned objects to replace the original object,the original object must be erased and then the returned objects must be added to a block table record.

如果分解的是图块,则返回的对象集合包含定义图块的各个图形对象。完成分解后,原对象保留不变。如果要用返回的对象集合代替原对象,需删除原对象然后将返回的对象集合添加到块表记录。

For more information about exploding objects,see “Disassociate Compound Objects (Explode)” in theAutoCAD User's Guide.

关于分解对象的更多内容,见AutoCAD用户指南中的“解除关联合成对象(分解)”。

Explode a polyline 分解多段线

This example creates a lightweight polyline object and then explodes the polyline into its simplest objects. After the polyline is exploded,it is disposed of and the returned objects are added to Model space.

本例创建一个轻量级多段线对象,然后将其分解为最简单的对象。多段线分解后将其从内存清除,将分解返回的对象添加到模型空间。

VB.NET

Imports Autodesk.AutoCAD.Runtime

Imports Autodesk.AutoCAD.ApplicationServices

Imports Autodesk.AutoCAD.DatabaseServices

Imports Autodesk.AutoCAD.Geometry

<CommandMethod("ExplodeObject")> _

Public Sub ExplodeObject()

'' Get the current document and database

Dim acDoc As Document = Application.DocumentManager.MdiActiveDocument

Dim acCurDb As Database = acDoc.Database

'' Start a transaction

Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction()

'' Open the Block table for read

Dim acBlkTbl As BlockTable

acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,_

OpenMode.ForRead)

'' Open the Block table record Model space for write

Dim acBlkTblRec As BlockTableRecord

acBlkTblRec = acTrans.GetObject(acBlkTbl(BlockTableRecord.ModelSpace),_

OpenMode.ForWrite)

'' Create a lightweight polyline

Using acPoly As Polyline = New Polyline()

acPoly.AddVertexAt(0,New Point2d(1,1),0)

acPoly.AddVertexAt(1,2),0)

acPoly.AddVertexAt(2,New Point2d(2,0)

acPoly.AddVertexAt(3,New Point2d(3,0)

acPoly.AddVertexAt(4,New Point2d(4,4),0)

acPoly.AddVertexAt(5,0)

'' Sets the bulge at index 3

acPoly.SetBulgeAt(3,-0.5)

'' Explodes the polyline

Dim acDBObjColl As DBObjectCollection = New DBObjectCollection()

acPoly.Explode(acDBObjColl)

For Each acEnt As Entity In acDBObjColl

'' Add the new object to the block table record and the transaction

acBlkTblRec.AppendEntity(acEnt)

acTrans.AddNewlyCreatedDBObject(acEnt,True)

Next

'' Dispose of the in memory polyline

End Using

'' Save the new objects to the database

acTrans.Commit()

End Using

End Sub

C#

using Autodesk.AutoCAD.Runtime;

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.DatabaseServices;

using Autodesk.AutoCAD.Geometry;

[CommandMethod("ExplodeObject")]

public static void ExplodeObject()

{

// Get the current document and database

Document acDoc = Application.DocumentManager.MdiActiveDocument;

Database acCurDb = acDoc.Database;

// Start a transaction

using (Transaction acTrans = acCurDb.TransactionManager.StartTransaction())

{

// Open the Block table for read

BlockTable acBlkTbl;

acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,

OpenMode.ForRead) as BlockTable;

// Open the Block table record Model space for write

BlockTableRecord acBlkTblRec;

acBlkTblRec = acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace],

OpenMode.ForWrite) as BlockTableRecord;

// Create a lightweight polyline

using (Polyline acPoly = new Polyline())

{

acPoly.AddVertexAt(0,new Point2d(1,0);

acPoly.AddVertexAt(1,0);

acPoly.AddVertexAt(2,new Point2d(2,0);

acPoly.AddVertexAt(3,new Point2d(3,0);

acPoly.AddVertexAt(4,new Point2d(4,0);

acPoly.AddVertexAt(5,0);

// Sets the bulge at index 3 顶点3、4之间的线段凸起

acPoly.SetBulgeAt(3,-0.5);

// Explodes the polyline分解多段线

DBObjectCollection acDBObjColl = new DBObjectCollection();

acPoly.Explode(acDBObjColl);

foreach (Entity acEnt in acDBObjColl)

{

// Add the new object to the block table record and the transaction

acBlkTblRec.AppendEntity(acEnt);

acTrans.AddNewlyCreatedDBObject(acEnt,true);

}

// Dispose of the in memory polyline清除内存中的多段线

}

// Save the new objects to the database提交修改

acTrans.Commit();

}

}

VBA/ActiveX Code Reference

Sub ExplodeObject()

Dim plineObj As AcadLWPolyline

Dim points(0 To 11) As Double

' Define the 2D polyline points

points(0) = 1: points(1) = 1

points(2) = 1: points(3) = 2

points(4) = 2: points(5) = 2

points(6) = 3: points(7) = 2

points(8) = 4: points(9) = 4

points(10) = 4: points(11) = 1

' Create a light weight Polyline object

Set plineObj = ThisDrawing.ModelSpace. _

AddLightWeightPolyline(points)

' Set the bulge on one segment to vary the

' type of objects in the polyline

plineObj.SetBulge 3,-0.5

' Explode the polyline

Dim explodedObjects As Variant

explodedObjects = plineObj.Explode

' Erase the polyline

plineObj.Erase

End Sub

(编辑:李大同)

【声明】本站内容均来自网络,其相关言论仅代表作者个人观点,不代表本站立场。若无意侵犯到您的权利,请及时与联系站长删除相关内容!

    推荐文章
      热点阅读